#INCLUDE "ADORDD.ch"
#INCLUDE "Dbstruct.ch"
#INCLUDE "Error.ch"
#INCLUDE "DbInfo.ch"

FUNCTION CreXlsFile( myXlsFile )
LOCAL bError, oError
LOCAL oConnect, oCatalog,oTable,oColumn
LOCAL aStructure, ii, iMax, xValue, cOldLang
LOCAL nMax, nEvery, nProz
LOCAL cField, nPosi, cType, cLine, nLen, nDec, cSql, cSelect, nStart,nStop
LOCAL mySheet  := "Sheet1"
LOCAL aValue := {}
LOCAL aField := {}

   IF EMPTY(myXlsFile)
      RETURN .F.
   ENDIF

   IF FILE(myXlsFile)
      FERASE(myXlsFile)
   ENDIF

   IF USED()
      aStructure := SP_aDbfStruct()              // same like DbStruct()
      IF EMPTY( aStructure )
         MsgInfo( "Error empty Structure,no FIELDs" )
         RETURN .F.
      ENDIF
      iMax := LEN( aStructure )

      // for progressbar
      * ExportDbf.ProgressBar_1.Value := 0
      nMax   := DBORDERINFO(DBOI_KEYCOUNT )
      nEvery := ROUND( nMax / 100, 0 )
   ELSE
      msgInfo( "need DBF" )
      RETURN .F.
   ENDIF

   cOldLang := hb_cdpSelect( 'UTF8EX' )

   SET CENTURY ON
   SET DATE GERMAN
   * SET DATE FORMAT "dd.mm.yyyy"

   oConnect := CreateObject( "ADODB.Connection" )

   bError := ERRORBLOCK( { | oErr | BREAK( oErr ) } )
   BEGIN SEQUENCE
      oConnect:Execute( "DROP TABLE " + myXlsFile )
   END SEQUENCE
   ERRORBLOCK( bError )

* ---------------------- Catalog ---------------------- *

   oCatalog := CreateObject( "ADOX.Catalog" )
   oCatalog:ActiveConnection := 'Provider=Microsoft.ACE.OLEDB.12.0;' + ;
            'Data Source=' + myXlsFile + ';' + ;
            'Extended Properties="Excel 12.0 Xml";'

* ---------------------- Create Table ----------------- *

   oTable   := CreateObject( "ADOX.Table" )
   oTable:Name := mySheet

   ii := 1
   FOR ii := 1 TO iMax
      cField := aStructure[ ii ] [ DBS_NAME ]
      cType  := aStructure[ ii ] [ DBS_TYPE ]

      oColumn  := CreateObject( "ADOX.Column")
      oColumn:Name := cField

      DO CASE
         CASE cType = "C" ; oColumn:Type := adVarWChar
         CASE cType = "M" ; oColumn:Type := adLongVarWChar
         CASE cType = "N" ; oColumn:Type := adDouble
         CASE cType = "D" ; oColumn:Type := adDate
         CASE cType = "L" ; oColumn:Type := adBoolean
      ENDCASE

      oTable:Columns:Append(oColumn)
   NEXT

   // add Table to Catalog
   oCatalog:Tables:Append(oTable)

* ---------------------- INSERT INTO ------------------ *

   oConnect:ConnectionString = 'Provider=Microsoft.ACE.OLEDB.12.0;' + ;
           'Data Source=' + myXlsFile + ';' + ;
           'Extended Properties="Excel 12.0 Xml";'

   oConnect:open()

   // prepare String for Fields
   cSelect := "( "
   ii := 1
   FOR ii := 1 TO iMax
      cField := aStructure[ ii ] [ DBS_NAME ]
      cSelect += cField
      IF ii < iMax
         cSelect += ", "
      ENDIF
   NEXT
   cSelect += " ) "

   // now start
   nStart := SECONDS()
   GO TOP
   DO WHILE !EOF()
      aField := {}
      aValue := {}
      ii := 1
      cSql := "INSERT INTO [Sheet1$] "+ cSelect + "VALUES ( "

      FOR ii := 1 TO iMax
         cField := aStructure[ ii ] [ DBS_NAME ]
         cType := aStructure[ ii ] [ DBS_TYPE ]
         nPosi := FIELDPOS( cField )
         xValue := FIELDGET( nPosi )

         DO CASE
            CASE cType = "C" ; xValue := "'"+STRTRAN( xValue,"'"," ")+"'"
*           CASE cType = "D" ; xValue := HB_STOT( DTOS( xValue ) + "000000" )
            CASE cType = "D" ; xValue := DTOS( xValue ) + "000000"
            CASE cType = "L" ; xValue := IF( xValue = .T., "TRUE","FALSE")
            CASE cType = "N" ; xValue := STR(xValue)
         ENDCASE

         cSql += xValue
         IF ii < iMax
           cSql += ","
         ENDIF
      NEXT
      cSql += ")"
      oConnect:Execute(cSql)

      SKIP
   ENDDO

   oConnect:Close()
   oConnect := NIL

   nStop := SECONDS()-nStart

   hb_cdpSelect( cOldLang )

RETURN .T.

*+ EOF: ADO.PRG
